
#ifndef _PRODUCER_CONSUMER_H__
#define _PRODUCER_CONSUMER_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

#define BUFFER_SIZE 5
#define MY_STRING_LEN 100

/*--- Shared Memory key ---*/
#define SHM_KEY 0x2A
#define SHM_PERM 0777

/*--- Semaphore key ---*/
#define SEM_KEY 0x2A
#define SEM_PERM 0777
#define SEM_NUM 3

#define SEM_MUTEX 0
#define SEM_FREE  1
#define SEM_AVAIL 2

#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
/* union semun is defined by including <sys/sem.h> */
#else
/* according to X/OPEN we have to define it ourselves */
union semun {
  /* value for SETVAL */
  int val;                    
  /* buffer for IPC_STAT, IPC_SET */
  struct semid_ds *buf;       
  /* array for GETALL, SETALL */
  unsigned short int *array;  
  /* buffer for IPC_INFO */
  struct seminfo *__buf;      
};
#endif

typedef struct {
  /*--- items werden als Stack organisiert:
    Top-of-Stack liegt immer bei numItemsInBuffer-1.
    Ist numItemsInBuffer == 0, ist der Stack leer ---*/ 
  int numItemsInBuffer;
  char userData[BUFFER_SIZE][MY_STRING_LEN];
} prod_con_shm_t;

#endif // _PRODUCER_CONSUMER_H__
